// linux.cpp

#include "jcpplisp.h"

CELL *cfunction::char_to_code(CELL *p,SYMVAL *loc,long locn,long lock)
{
    CELL *q,*r,*s;
    AINT *i;

    if (p->attr != 'l') goto serror;
    s = p->car;
    IncCellStack(NULL);
    IncCellStack(p);
    q = eval(s,loc,locn,lock);
    PopCellStack();
    if (q == NULL) return NULL;
    if (q->attr != 'm') goto serror;
#if LINUXCOMPILER
    i = (AINT *)getInt(((unsigned long)(q->car)) & 0xff);
#else
    unsigned char a[1];
    a[0] = ((unsigned long)(q->car)) & 0xff;
//printf("%d\n",a[0]);
    if (!isKanji(a)) {
	i = (AINT *)getInt(a[0]);
    }
    else {
	i = (AINT *)getInt(((unsigned long)a[0]) * 0x100 + (((unsigned long)(q->cdr)) & 0xff));
    }
#endif
    r = getCell();
    r->attr = 'i';
    r->car = (CELL *)i;
    r->cdr = NULL;
    return r;

 serror:
    printf("G[: CHAR-CODE̎gԈĂ܂B\n");
    errorlisp(loc,locn);
    return NULL;
}

CELL *cfunction::code_to_char(CELL *p,SYMVAL *loc,long locn,long lock)
{
    CELL *q,*r,*s;
    long c;

    if (p->attr != 'l') goto serror;
    s = p->car;
    IncCellStack(NULL);
    IncCellStack(p);
    q = eval(s,loc,locn,lock);
    PopCellStack();
    if (q == NULL) return NULL;
    if (q->attr != 'i') goto serror;
    c = (((AINT *)(q->car))->f);
    if (c < 0) goto serror;
#if LINUXCOMPILER
    c &= 0xff;
    r = getCell();
    r->attr = 'm';
    r->car = (CELL *)c;
    r->cdr = NULL;
#else
    long c2;
    c2 = c / 0x100;
    c &= 0xff;
    r = getCell();
    r->attr = 'm';
    if (c2 > 0) {
	r->car = (CELL *)c2;
	r->cdr = (CELL *)c;
    }
    else {
	r->car = (CELL *)c;
	r->cdr = NULL;
    }
#endif
    return r;

 serror:
    printf("G[: CODE-CHAR̎gԈĂ܂B\n");
    errorlisp(loc,locn);
    return NULL;
}

// end of file

